import java.util.List;
import java.util.ArrayList;
import java.lang.NullPointerException;

public class MyFilteredSequence<E> extends MySequence<E> {
    // Overview: Tipo delle sequenze finite di oggetti di tipo E di dimensioni e contenuto
    // modificabili i cui elementi possono essere null ma non possono appartenere a un
    // sotto-insieme fissato di oggetti di tipo E
    // AF = come per MySequence
    // IR = come per MySequence e
    //      forall i. 0 <= i < dim -> !vietati.contains(this.get(i))
     
    private List<E> vietati;
    
    public MyFilteredSequence () {
        this(new ArrayList<E>());
    }

    public MyFilteredSequence (List<E> lst) {
        super();
        vietati = lst;
    }

    /* modifica la sequenza inserendo alla posizione pos l'oggetto elem, nel caso che elem
     non sia fra gli elementi proibiti
     */
    public void update(int pos, E elem) {
        if (!vietati.contains(elem))
            super.update(pos,elem);
    }
    /*
     @Modifies: this
     @effects: modifica la sequenza eseguendo super.update(pos,elem), nel caso che elem non
     appartenga all'insieme vietati
     */
}
